// Splitter by alice3589 using Wschseng's [A] splitter as a base which was made with the help of Rod, Jeff and aloyark.

//Values and logic for splitting on the name confirmation done by aloyark
state("NieR Replicant ver.1.22474487139", "1.00")
{
	byte Loading: 0x00EE29B0, 0xD4;
	string32 Event: 0x15C3163;
	string32 characterName: 0x43727BC;
	string32 nameInput: 0x017B6EB0, 0x58, 0x710, 0x7E0;
	string32 question: 0x017B6EB0, 0x58, 0x710, 0x6E0;
}

state("NieR Replicant ver.1.22474487139", "1.03")
{
	byte Loading: 0x00EE49C0, 0xD4;
	string32 Event: 0x15C53F3;
	string32 characterName: 0x437DCAC;
	string32 nameInput: 0x017B9140, 0x58, 0x710, 0x7E0;
	string32 question: 0x017B9140, 0x58, 0x710, 0x6E0;
}


init
{

	byte[] exeMD5HashBytes = new byte[0];
	using (var md5 = System.Security.Cryptography.MD5.Create())
	{
        	using (var s = File.Open(modules.First().FileName, FileMode.Open, FileAccess.Read, FileShare.ReadWrite))
		{
            	exeMD5HashBytes = md5.ComputeHash(s); 
        	}
	}
	var MD5Hash = exeMD5HashBytes.Select(x => x.ToString("X2")).Aggregate((a, b) => a + b);

	print("hashy boi is: " + MD5Hash);
	switch (MD5Hash) {
		case "3306698C51503A7783BD401712d9AC6C":
			version = "1.00";
			break;
		case "E5411222E5247B981EF2B1FC219B770A":
			version = "1.03";
			break;
		case "89E4C3D0AF6C86DB2312FB911DAFEC91":
			version = "1.03";
			break;
	}
	print("ModuleMemorySize: " + modules.First().ModuleMemorySize.ToString());
}


startup
{
	vars.Events = new string[] {
	
	//Prologue
	//"eid_0050_a0010",			//start
	"eid_0050_a0032",			//magic get
	"eid_0050_a0050",			//prologue end
	
	//First half
	
	//Hänsel und Gretel
	//"eid_0100_a0010",		
	"eid_0200_a0012",			//lost shrine movement
	"eid_0200_a0050",			//hensel und gretel start
	"eid_0200_a0060",			//phase 1 end
	"eid_0200_a0070",			//phase 2 end
	"eid_0200_a0080",			//hänsel und gretel end
	
	//Hook 1
	"eid_1000_a0010",			//the aerie discovery
	"eid_1000_a0030",			//kainé start
	"eid_1000_a0040",			//kainé phase 1 end
	"eid_1000_a0050",			//Hook 1 start
	"eid_1000_a0070",			//Hook 1 end
	
	//Geppetto
	"eid_1320_a0010",			//seafront discovery
	"eid_1200_a0005",			//junk heap discovery
	"eid_1270_a0030",			//geppetto start
	"eid_1270_a0040",			//geppetto end
	
	//Hook 2
	"eid_1050_a0020",			//hook 2 start
	"eid_1050_a0030",			//phase 1 end
	"eid_1050_a0040",			//phase 2 end
	"eid_1050_a0060",			//phase 3 end
	"eid_1050_a0070",			//hook 2 end
	
	// "eid_9400_a0080",                 //Robot Fight Start
	"eid_9400_a0130",			         //Maso Kainé Fight Phase 2
	"eid_9400_a0180",                    //Breaking Fragment
	"eid_9400_a0200",                    //Hook Start
	"eid_9400_a0230",                    //Hook Phase 2
	};
}

start
{
//return current.Event == "eid_0050_a0010";
return current.Loading > 4;
}

split
{
	foreach (string events in vars.Events)
	{
		if (current.Event == events && current.Event != old.Event)
		{
			return true;
		}
	}

	return (old.nameInput == current.characterName && current.question != "Who do I love more than anyone?");
}

isLoading
{
	return current.Loading > 4;
}